﻿
using System;
using System.Diagnostics;
using System.Threading;
using System.Threading.Tasks;
using Wisej.Web;

namespace WisejKeyPress
{
    public partial class Window1 : Form
    {
        private CancellationTokenSource _cancellationTokenValidation = new CancellationTokenSource();

        public Window1()
        {
            InitializeComponent();
        }

        private void NumericUpDown1_KeyPress(object sender, KeyPressEventArgs e)
        {
            NumericUpDown origin = sender as NumericUpDown;
            if (!origin.ContainsFocus)
            {
                return;
            }

            ExecuteValidateAsync(() =>
            {
                Validate();
            });
        }

        private async void ExecuteValidateAsync(Action onExpired = null)
        {
            try
            {
                // gestione ricerca con task di cancellazione
                CancellationTokenSource tokenToCancel = Interlocked
                    .Exchange(ref _cancellationTokenValidation, new CancellationTokenSource());

                tokenToCancel.Cancel();

                await Task.Delay(TimeSpan.FromMilliseconds(1000), _cancellationTokenValidation.Token)
                    .ContinueWith(delegate
                    {
                        //Application.RunInContext(this, new Action(async () =>
                        //{

                        //Application.StartPolling(1000);

                        //await Application.StartTask(() =>
                        //{
                        Application.Update(this, () =>
                        {
                            onExpired?.Invoke();
                        });
                        //});

                        //Application.EndPolling();
                        //}));
                    },
                    CancellationToken.None,
                    TaskContinuationOptions.OnlyOnRanToCompletion);
            }
            catch (OperationCanceledException ocex)
            {
                Debug.WriteLine($"{nameof(Window1)}.{nameof(ExecuteValidateAsync)} " +
                    $"task search canceled: {ocex.Message}");
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Errore",
                    MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
            }
        }

        private void TxtDataSpedizione_KeyPress(object sender, KeyPressEventArgs e)
        { 
            ExecuteValidateAsync(() =>
            {
                Validate();
            });
        }
    }
}
